Lavalite package that provides f_x_c management facility for the cms.

## Installation

Run the below command form the root folder of lavalite.

```
    composer require "none/f_x_c"
```


## Migration and seeds

```
    php artisan migrate
    php artisan db:seed --class=None\\FXC\\Seeders\\FXCTableSeeder
```

## Publishing

* Configuration
```
    php artisan vendor:publish --provider="None\FXC\Providers\FXCServiceProvider" --tag="config"
```
* Language
```
    php artisan vendor:publish --provider="None\FXC\Providers\FXCServiceProvider" --tag="lang"
```
* Views
```
    php artisan vendor:publish --provider="None\FXC\Providers\FXCServiceProvider" --tag="view"
```


## URLs and APIs


### Web Urls

* Admin
```
    http://path-to-route-folder/admin/f_x_c/{modulename}
```

* User
```
    http://path-to-route-folder/user/f_x_c/{modulename}
```

* Public
```
    http://path-to-route-folder/f_x_c_s
```


### API endpoints

These endpoints can be used with or without `/api/`
And also the user can be varied depend on the type of users, eg user, client, admin etc.

#### Resource

* List
```
    http://path-to-route-folder/api/user/f_x_c/{modulename}
    METHOD: GET
```

* Create
```
    http://path-to-route-folder/api/user/f_x_c/{modulename}
    METHOD: POST
```

* Edit
```
    http://path-to-route-folder/api/user/f_x_c/{modulename}/{id}
    METHOD: PUT
```

* Delete
```
    http://path-to-route-folder/api/user/f_x_c/{modulename}/{id}
    METHOD: DELETE
```

#### Public

* List
```
    http://path-to-route-folder/api/f_x_c/{modulename}
    METHOD: GET
```

* Single Item
```
    http://path-to-route-folder/api/f_x_c/{modulename}/{slug}
    METHOD: GET
```

#### Others

* Report
```
    http://path-to-route-folder/api/user/f_x_c/{modulename}/report/{report}
    METHOD: GET
```

* Export/Import
```
    http://path-to-route-folder/api/user/f_x_c/{modulename}/exim/{exim}
    METHOD: POST
```

* Action
```
    http://path-to-route-folder/api/user/f_x_c/{modulename}/action/{id}/{action}
    METHOD: PATCH
```

* Actions
```
    http://path-to-route-folder/api/user/f_x_c/{modulename}/actions/{action}
    METHOD: PATCH
```

* Workflow
```
    http://path-to-route-folder/api/user/f_x_c/{modulename}/workflow/{id}/{transition}
    METHOD: PATCH
```
