<?php

namespace None\FXC\Http\Controllers;

use App\Http\Controllers\Controller as BaseController;
use Exception;
use None\FXC\Http\Requests\TestActionsRequest;
use None\FXC\Models\TestActions;

/**
 * Admin web controller class.
 */
class TestActionsController extends BaseController
{

    /**
     * Action controller function for test.
     *
     * @param Model $model
     * @param action next action for the model.
     *
     * @return Response
     */
    public function __invoke(TestActionsRequest $request, $action)
    {
        try {
            $test = TestActions::run($request, $action);
            return $this->response->message(trans('messages.success.updated', ['Module' => trans('f_x_c::test.name')]))
                ->code(204)
                ->data(compact('data'))
                ->status('success')
                ->url(guard_url('f_x_c/test/' . $action))
                ->redirect();
        } catch (Exception $e) {
            return $this->response->message($e->getMessage())
                ->code(400)
                ->status('error')
                ->url(guard_url('f_x_c/test/' . $action))
                ->redirect();
        }
    }
}
