<?php

namespace None\FXC\Http\Controllers;

use App\Http\Controllers\ActionController as BaseController;
use Exception;
use Illuminate\Support\Str;
use None\FXC\Actions\TestExim;
use None\FXC\Http\Requests\TestEximRequest;

/**
 * Admin web controller class.
 */
class TestEximController extends BaseController
{
    /**
     * Action controller function for test.
     *
     * @param Model $model
     * @param action next action for the model.
     *
     * @return Response
     */
    public function __invoke(TestEximRequest $request, $exim)
    {
        try {
            $function = Str::camel($exim);
            $data = TestExim::$function($request);
            return $this->response->message(trans('messages.success.updated', ['Module' => trans('f_x_c:test.name')]))
                ->code(204)
                ->data(compact('data'))
                ->status('success')
                ->url(guard_url('f_x_c/test/' . $exim))
                ->redirect();
        } catch (Exception $e) {
            return $this->response->message($e->getMessage())
                ->code(400)
                ->status('error')
                ->url(guard_url('f_x_c/test/' . $exim))
                ->redirect();
        }
    }
}
