<?php

namespace None\FXC\Policies;

use None\FXC\Models\Test;
use Litepie\User\Interfaces\UserPolicyInterface;

trait TestAction
{

    /**
     * Determine if the given user can approve the given test.
     *
     * @param UserPolicyInterface $authUser
     *
     * @return bool
     */
    public function copy(UserPolicyInterface $authUser, Test $test)
    {
        if ($authUser->is($this->model->owner())) {
            return true;
        }

        if ($authUser->canDo('f_x_c.test.action.copy')) {
            return true;
        }

        return false;
    }

    /**
     * Determine if the given user can approve the given test.
     *
     * @param UserPolicyInterface $authUser
     *
     * @return bool
     */
    function empty(UserPolicyInterface $authUser, Test $test) {
        if ($authUser->is($this->model->owner())) {
            return true;
        }

        if ($authUser->canDo('f_x_c.test.action.empty')) {
            return true;
        }

        return false;
    }

    /**
     * Determine if the given user can approve the given test.
     *
     * @param UserPolicyInterface $authUser
     *
     * @return bool
     */
    public function transfer(UserPolicyInterface $authUser, Test $test)
    {
        if ($authUser->is($this->model->owner())) {
            return true;
        }

        if ($authUser->canDo('f_x_c.test.action.transfer')) {
            return true;
        }

        return false;
    }

    /**
     * Determine if the given user can approve the given test.
     *
     * @param UserPolicyInterface $authUser
     *
     * @return bool
     */
    public function delete(UserPolicyInterface $authUser, Test $test)
    {


        if ($authUser->canDo('f_x_c.test.action.delete')) {
            return true;
        }

        return false;
    }


}
